//---------------------------------------------------------------------------
#ifndef MainWindowH
#define MainWindowH
#define titleText "Sprite Painter 1.35"
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "cgrid.h"
#include <Grids.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include <Chart.hpp>
#include <TeEngine.hpp>
#include <TeeProcs.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TformMain : public TForm
{
__published:	// IDE-managed Components
    TDrawGrid *drawGrid;
    TCheckBox *chkGrid;
    TBevel *Bevel1;
    TBevel *Bevel3;
    TShape *colorPal1;
    TShape *colorPal5;
    TShape *colorPal9;
    TShape *colorPal13;
    TShape *colorPal2;
    TShape *colorPal6;
    TShape *colorPal10;
    TShape *colorPal14;
    TShape *colorPal0;
    TShape *colorPal4;
    TShape *colorPal8;
    TShape *colorPal12;
    TShape *colorPal3;
    TShape *colorPal7;
    TShape *colorPal11;
    TShape *colorPal15;
    TBevel *Bevel4;
    TLabel *lbl2;
    TCheckBox *chkMultiColor;
    TSaveDialog *saveDialog;
    TOpenDialog *openDialog;
    TSpeedButton *btnLeft;
    TSpeedButton *btnRight;
    TSpeedButton *btnUp;
    TSpeedButton *btnDown;
    TButton *btnClear;
    TButton *btnUndo;
    TBevel *Bevel5;
    TBevel *Bevel6;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TMainMenu *MainMenu;
    TMenuItem *menu0;
    TMenuItem *itemNew;
    TMenuItem *br1;
    TMenuItem *itemOpen;
    TMenuItem *itemSave;
    TMenuItem *itemSaveAs;
    TMenuItem *br2;
    TMenuItem *exportRawSprite0;
    TMenuItem *br3;
    TMenuItem *itemExit;
    TMenuItem *SaveEditBuffer1;
    TMenuItem *LoadEditbuffer1;
    TStatusBar *statusBar;
    TLabel *Label4;
    TBevel *Bevel7;
    TMenuItem *menu1;
    TMenuItem *About1;
    void __fastcall saveRawSprite();
    void __fastcall drawGridDrawCell(TObject *Sender, int Col, int Row,
          TRect &Rect, TGridDrawState State);
    void __fastcall drawGridMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall drawGridMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall itemNewClick(TObject *Sender);
    void __fastcall chkMultiColorClick(TObject *Sender);
    void __fastcall colorPalMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall chkGridClick(TObject *Sender);
    void __fastcall itemExitClick(TObject *Sender);
    void __fastcall itemSaveAsClick(TObject *Sender);
    void __fastcall itemOpenClick(TObject *Sender);
    void __fastcall itemSaveClick(TObject *Sender);
    void __fastcall drawGridMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall colorSampleMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall exportRawSpriteClick(TObject *Sender);
    void __fastcall btnClearClick(TObject *Sender);
    void __fastcall btnUndoClick(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall btnRightClick(TObject *Sender);
    void __fastcall btnLeftClick(TObject *Sender);
    void __fastcall btnDownClick(TObject *Sender);
    void __fastcall btnUpClick(TObject *Sender);
    void __fastcall setThumbColors();
    void __fastcall thumbMouseDown(TObject *Sender,
                     TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall LoadEditbuffer1Click(TObject *Sender);
    void __fastcall SaveEditBuffer1Click(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall copyBufferToThumb();
    void __fastcall setThumbPixel(int x, int y, int colIndex,
          int thumbX, int thumbY);

    void __fastcall About1Click(TObject *Sender);
private:	// User declarations
    struct ColorStruct
    {
      TColor color[4];
    };

    bool thumbBuffer[24*4][21*4];
    ColorStruct thumbColor[4][4];
    bool multiColor[4][4];
    TImage *imgThumb[4][4];

    bool pixelColor[24][21];
    bool undoBuffer[24][21];
    bool pixelColorTemp[24][21];

    TShape *colorSample[4];
    TColor commColor[16];

    bool modified;
    int lastColor;
    String lastFile;
    bool mouseLeftButton;

    struct
    {
      int x, y;
    } actThumb;

    struct SpriteFile
    {
      char idString[6];
      TColor col[4];
      bool multiColor;
      bool pixelColor[24][21];
    };

    struct ThumbFile
    {
      char idString[5];
      ColorStruct thumb[4][4];
      bool grid;
      bool thumbMultiColor[4][4];
      bool pixelColor[24*4][21*4];
    };

public:		// User declarations
    __fastcall TformMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TformMain *formMain;
//---------------------------------------------------------------------------
#endif
